<h1 align="center"> Tugas Besar Rekayasa Perangkat Lunak IF2250 </h1>
<h1 align="center">  Sistem Storage Manager - WareHosea </h1>


## Table of Contents
1. [General Information](#general-information)
2. [Contributors](#contributors)
3. [How to Run The Program](#how-to-run-the-program)
4. [Daftar Modul](#daftar-modul)
5. [Daftar Tabel Basis Data](#daftar-tabel-basis-data)



## General Information
WareHosea adalah sistem perangkat lunak storage manager berbasis aplikasi desktop yang bernama yang akan mempermudah administrator dalam proses mengelola dan melacak barang-barang yang ada di beberapa warehouse. Sistem ini akan menampilkan nama barang, kode barang, deskripsi barang, jumlah stok barang, gambar barang, dan status pengiriman barang. Selain itu sistem juga akan menampilkan nama warehouse, id warehouse, lokasi warehouse, kapasitas maksimum warehouse, dan kapasitas terkini warehouse. Pengguna dapat melakukan pengelolaan stok barang-barang yang ada di berbagai warehouse dengan fungsi create, update, delete, dan read (CRUD). Selain itu, dengan sistem ini pengguna dapat melakukan pemindahan barang dari warehouse yang satu ke warehouse yang lainnya, baik satu barang maupun semua barang sekaligus. Sistem ini dapat melakukan pencarian suatu barang atau warehouse berdasarkan kata kunci yang diberikan menggunakan fungsi search.
 


## Contributors
|   NIM    |                  Nama                  |
| :------: | :------------------------------------: |
| 13522013 |         Denise Felicia Tiowanni        |
| 13522053 |       Erdianti Wiga Putri Andini       |
| 13522063 |         Shazya Audrea Taufik           |
| 13522085 |          Zahira Dina Amalia            |
| 13522087 |                Shulha                  |
| 10023608 |             Tazkirah Amaliah           |


## How to Run The Program
1. Clone repository ini dengan mengetikkan `git clone https://gitlab.informatika.org/wigglomigglo/if2250-2024-k01-10-warehosea.git pada terminal`
2. Buka folder yang telah di-clone
3. Ketik `cd src` pada terminal
4. Karena default OS pada aplikasi ini menggunakan MacOS, maka ketik `python3 main.py`
5. Login sesuai dengan username dan password pada database
6. Fitur aplikasi siap digunakan


## Daftar Modul
|   Modul    |                  PIC                  |
| :--------: | ------------------------------------- |
| Manipulasi Data Admin | 13522063, 13522013 (UI)        |
| Manipulasi Data Warehouse | 13522053, 13522013 (UI)     |
| Manipulasi Data Barang | 13522085, 13522087, 13522013 (UI)         |

### Manipulasi Data Admin
![LamanLogin](doc/Laman_Login.png)
![EditProfile](doc/Edit_Profile.png)


### Manipulasi Data Warehouse
![ListWarehouse](doc/List_Warehouse.png)
![DetailWarehouse](doc/Detail_Warehouse.png)
![TambahWarehouse](doc/Tambah_Warehouse.png)

### Manipulasi Data Barang
![ListBarang](doc/Detail_Warehouse.png)
![DetailBarang](doc/Detail_Barang.png)
![TambahBarang](doc/Tambah_Barang.png)
![PindahBarang](doc/Pindah_Barang.png)


## Daftar Tabel Basis Data
1. admin(
        surel VARCHAR(255) NOT NULL,
        nama VARCHAR(255) NOT NULL,
        password VARCHAR(255) NOT NULL,
	noTelp VARCHAR(255) NOT NULL,
        PRIMARY KEY(surel)
        )

2. barang(
         id_warehouse INTEGER(11) NOT NULL,
 	 id_barang VARCHAR(5) NOT NULL,
  	 nama_barang text NOT NULL,
  	 deskripsi_barang text DEFAULT NULL,
    	 stok INTEGER(11) NOT NULL,
  	 foto VARCHAR(255) DEFAULT NULL,
  	 status_pengiriman` enum('Dalam Pengiriman','Berada di Warehouse') DEFAULT NULL,
  	 PRIMARY KEY (id_warehouse,id_barang)
	)

3. warehouse(
        id_warehouse INTEGER(11) NOT NULL AUTO_INCREMENT,
 	nama_warehouse VARCHAR(30) NOT NULL,
  	kapasitas_maksimum INTEGER(11) DEFAULT NULL,
  	kapasitas_terkini INTEGER(11) NOT NULL,
  	alamat VARCHAR(255) NOT NULL,
  	id_admin VARCHAR(255) DEFAULT NULL,
  	PRIMARY KEY (id_warehouse),
  	KEY fk_id_admin (id_admin),
  	CONSTRAINT fk_id_admin FOREIGN KEY (id_admin) REFERENCES admin (surel))
        )