from classes.Admin import Admin

class AdminController:
    def __init__(self):
        self.admins = Admin.load_all_admins()

    def update_profil(self, profile_data):
        surel = profile_data[0]
        admin = next((admin for admin in self.admins if admin.get_surel() == surel), None)
        if admin:
            new_name = profile_data[1]
            if new_name:
                admin.set_nama(new_name)
            
            new_password = profile_data[2]
            if new_password:
                if len(new_password) < 8:
                    return False, "Password minimal 8 karakter."
                admin.set_password(new_password)
            
            new_notelp = profile_data[3]
            if new_notelp:
                admin.set_no_telp(new_notelp)
            
            admin.update_in_db()
            return True, "Profil berhasil diubah."
        return False, "Admin profil tidak ditemukan."


    def validate_admin(self, email, password):
        admin = next((admin for admin in self.admins if admin.get_surel() == email and admin.get_password() == password), None)
        if admin:
            return True
        else:
            return False

    def lihat_profil(self):
        admin = self.admins[0]
        element = []
        element.append(admin.get_surel())
        element.append(admin.get_nama())
        element.append(admin.get_password())
        element.append(admin.get_no_telp())
        return element
       
# admin_controller = AdminController()
# admin_controller.validate_admin()
# admin_controller.update_profil()