import sys, os
import uuid
from shutil import copyfile
from PyQt5.QtWidgets import QApplication, QWidget, QLabel, QPushButton, QLineEdit, QVBoxLayout, QHBoxLayout, QScrollArea, QFileDialog, QComboBox, QMessageBox
from PyQt5.QtGui import QPixmap, QIcon, QFont, QFontDatabase, QPainter, QPainterPath
from PyQt5.QtCore import Qt, QEvent, pyqtSignal


class IconTextButtonItem(QPushButton):
    def __init__(self, icon_path, text, parent=None):
        super().__init__(parent)

        fontPath = os.path.abspath("../img/assets/Nunito.ttf")
        fontId = QFontDatabase.addApplicationFont(fontPath)
        fontFamily = QFontDatabase.applicationFontFamilies(fontId)[0]
        customFont = QFont(fontFamily, 20)

        self.setFixedSize(459, 77)  

        scaled_pixmap = QPixmap(icon_path).scaled(400, 70, Qt.KeepAspectRatio, Qt.SmoothTransformation)
        self.setIcon(QIcon(scaled_pixmap))
        self.setIconSize(scaled_pixmap.size())

        # label untuk nama warehouse
        self.text_label = QLabel(text, self)
        self.text_label.setFont(customFont)
        self.text_label.setAlignment(Qt.AlignLeft | Qt.AlignVCenter) 
        self.text_label.setStyleSheet("color: white; font-size: 18pt")
        self.text_label.setGeometry(100, 0, self.width(), self.height())