from PyQt5.QtWidgets import QWidget, QLabel, QPushButton
from PyQt5.QtGui import QPixmap, QIcon
from PyQt5.QtCore import Qt
from classes.AdminController import AdminController
from classes.LoginDisplay import LoginDisplay


class InitLoginDisplay(QWidget):
    def __init__(self):
        super().__init__()
        self.initUI()
    
    def initUI(self):
        self.setFixedSize(1400, 800)

        self.background = QLabel(self)
        self.pixmap = QPixmap('../img/assets/page1/bg.png')
        self.background.setPixmap(self.pixmap.scaled(1440, 1024, Qt.KeepAspectRatioByExpanding, Qt.SmoothTransformation))
        self.background.resize(self.width(), self.height())

        self.login_label = QLabel(self)
        self.login_label.setPixmap(QPixmap('../img/assets/page1/warehosea.png').scaled(600, 150, Qt.KeepAspectRatio, Qt.SmoothTransformation))
        self.login_label.move(420, 250)

        self.text_label = QLabel(self)
        self.text_label.setPixmap(QPixmap('../img/assets/page1/login_text.png').scaled(400, 100, Qt.KeepAspectRatio, Qt.SmoothTransformation))
        self.text_label.move(520, 450)

        self.login_button = QPushButton(self)
        scaled_pixmap = QPixmap('../img/assets/page1/login2.png').scaled(400, 120, Qt.KeepAspectRatio, Qt.SmoothTransformation)
        self.login_button.setIcon(QIcon(scaled_pixmap))
        self.login_button.setIconSize(scaled_pixmap.size())
        self.login_button.setFixedSize(scaled_pixmap.size())
        self.login_button.setStyleSheet("QPushButton { border: none; }")
        self.login_button.move(520, 530)
        self.login_button.clicked.connect(self.open_main_page)

        self.nim_label = QLabel(self)
        self.nim_label.setPixmap(QPixmap('../img/assets/page1/nim.png').scaled(400, 100, Qt.KeepAspectRatio, Qt.SmoothTransformation))
        self.nim_label.move(520, 730)

        self.setWindowTitle('Login Screen')

    def open_main_page(self):
        admin_controller = AdminController()
        self.main_page = LoginDisplay(admin_controller)
        self.main_page.show()
        self.close()