import mysql.connector
from mysql.connector import Error
from classes.Warehouse import Warehouse
from classes.ListWarehouse import ListWarehouse

class WarehouseController:
    def __init__(self, host='localhost', database='warehosea', user='root', password='170611'):
        self.host = host
        self.database = database
        self.user = user
        self.password = password


    def connect(self):
        try:
            conn = mysql.connector.connect(
                host=self.host,
                database=self.database,
                user=self.user,
                password=self.password
            )
            if conn.is_connected():
                return conn
        except Error as e:
            print(f"Error connecting to MySQL: {e}")


    def tambah_warehouse(self, name, max_capacity, location):
        conn = self.connect()
        if conn:
            if Warehouse.check_name(conn, name):
                return False, "Warehouse dengan nama tersebut sudah ada. Silakan gunakan nama lain."
            Warehouse.add(conn, name, max_capacity, location)
            conn.close()
            return True, "Warehouse berhasil ditambahkan."
        return False, "Database connection failed."


    def hapus_warehouse(self, id_warehouse):
        conn = self.connect()
        if conn:
            Warehouse.deleteBarangFromWH(conn, id_warehouse)
            Warehouse.deleteWH(conn, id_warehouse)
            # print("Warehouse berhasil dihapus.")
            conn.close()


    def update_warehouse(self, id_warehouse, updates):
        conn = self.connect()
        if conn:
            try:
                Warehouse.update(conn, id_warehouse, updates)
                conn.commit()  
                return True, "Warehouse updated successfully."
            except Exception as e:
                conn.rollback()
                return False, f"Update failed: {str(e)}"
            finally:
                conn.close()
        else:
            return False, "Failed to connect to the database."


    def search_warehouse(self, part_name):
        conn = self.connect()
        if conn:
            results = Warehouse.search(conn, part_name)
            return results

    def lihat_daftar_warehouse(self):
        conn = self.connect()
        if conn:
            results = ListWarehouse.get_list_warehouse(conn)
            conn.close()
            return results

    def lihat_warehouse(self, id_warehouse):
        conn = self.connect()
        if conn:
            # id_warehouse = input("Enter the warehouse ID: ")
            results = Warehouse.find_by_id(conn, id_warehouse)
            return results
        
    def total_warehouse(self):
        conn = self.connect()
        if conn:
            result = Warehouse.get_num_warehouse(conn)
            return result