# tests/test_list_warehouse.py

import sys
import os
import pytest
import mysql.connector

root_dir = os.path.abspath(os.path.join(os.path.dirname(__file__), '..'))
sys.path.append(root_dir + '/src')

from classes.ListWarehouse import ListWarehouse

DB_CONFIG = {
    'host': 'localhost',
    'database': 'warehosea',
    'user': 'root',
    'password': '170611'
}

@pytest.fixture(scope="module")
def db_connection():
    conn = mysql.connector.connect(**DB_CONFIG)
    yield conn
    conn.close()

def test_get_list_warehouse(db_connection):
    cursor = db_connection.cursor()
    cursor.execute("INSERT INTO warehouse (nama_warehouse, kapasitas_maksimum, alamat, kapasitas_terkini, id_admin) VALUES (%s, %s, %s, %s, %s)", 
                   ("Test Warehouse", 100, "Test Address", 50, 'hoseaganteng@gmail.com'))
    db_connection.commit()
    
    warehouses = ListWarehouse.get_list_warehouse(db_connection)
    
    assert len(warehouses) > 0
    assert 'id_warehouse' in warehouses[0]
    assert 'nama_warehouse' in warehouses[0]
    assert 'kapasitas_maksimum' in warehouses[0]
    assert 'alamat' in warehouses[0]
    assert 'kapasitas_terkini' in warehouses[0]
    
    cursor.execute("DELETE FROM warehouse WHERE nama_warehouse = %s", ("Test Warehouse",))
    db_connection.commit()
    cursor.close()

# Run the test
if __name__ == "__main__":
    pytest.main()
